#!perl -w

# This script copies source from pc to linux cluster
# This is a perl script to convert ascii pc source files into unix eol files

# bring in the perl module that includes copy
use File::Copy;

# base name for where we are
$basename = "c:/projects/Cloudy/oldcloudy/C06_02/";

# --------------------------------------------------------------------------
# this block - set up paths to all targets on various machines 

# this is where the original source files live on my pc
#$original_source_dir = "c:/projects/cloudy/trunk/source";
$original_source_dir = "$basename"."source";

# the root dir where the unix files will live on the linux cluster
$cluster_unix_source_dir = "u:/cloudy/trunk/source";

# this is the ftp site on gradj
$ftp_last = "u:/pub/gary/bleeding_edge/last/";

# the root dir where the unix files will live on my pc
#$local_unix_source_dir = "c:/projects/cloudy/trunk/unix/source";
$local_unix_source_dir = "$basename"."unix/source";

#$local_unix_main_dir = "c:/projects/cloudy/trunk/unix";
$local_unix_main_dir = "$basename"."unix";

# the win dir within the unix set
#$local_win_source_dir = "c:/projects/cloudy/trunk/win/source"; 
$local_win_source_dir = "$basename"."win/source"; 

#this is where backup files will be dropped
#$unixhome = "c:/projects/cloudy/trunk/unix";
$unixhome = "$basename"."unix";

#$winhome = "c:/projects/cloudy/trunk/win";
$winhome = "$basename"."win";
# end block - set up paths to all targets on various machines

# --------------------------------------------------------------------------
# --------------------------------------------------------------------------
# this block - clean out the target directories so we get fresh copies
# move to the old unix source directory, where we will delete all files
#
# move to pc unix source dir
chdir( "$local_unix_source_dir" ) or die " invalid pc unix target directory for source\n";
print(" moved to pc unix target source directory, about to delete all files\n");
# remove the unix source files
unlink <*> ; 

# move to win source dir
chdir( "$local_win_source_dir" ) or die " invalid win target directory for source\n";
print(" moved to win target source directory, about to delete all files\n");
# remove the win source files
unlink <*> ; 

# move to the cluster source directory
chdir( "$cluster_unix_source_dir" ) or die " invalid cluster target directory for source\n";
print(" moved to unix target source directory, about to delete all files\n");
# remove the old source files
unlink <*.c> ; 


# --------------------------------------------------------------------------
# move to where the original source files live 
chdir( "$original_source_dir" ) or die " invalid original target directory for source\n";

# this loops over all files in the original source directory
# and copies unix eol version to subdir unix, which is now empty
# also copies win version to subdir win/source, which is now empty
while( defined( $input = glob("*") ) )
{
	print( "$input going to " );
	$output = "$local_unix_source_dir"."/"."$input";
	print("$output\n");
	# actually execute the code
	system "dos2unix < $input  > $output";
#
#       now do win version
	print( "$input going to " );
	$output = "$local_win_source_dir"."/"."$input";
	print("$output\n");
	# simply copy the source here
	copy( $input  , $output );
}

# this jpeg file was damaged above, so now copy straight version over 
copy( "clouds.jpg" , "$local_unix_source_dir"."/"."clouds.jpg" );

print("\n=========================\n");
print("All source files have been copies to unix/source subdir\n");
print("=========================\n");

# move to local unix source directory with unix eol source
chdir( $local_unix_source_dir ) or die " invalid local unix source directory for input\n";

# this loops over all files in the local unix source directory
# and copies unix version to cluster source, which should be empty
while( defined( $input = glob("*") ) )
{
	print( "$input going to " );
	$output = "$cluster_unix_source_dir"."/"."$input";
	print("$output\n");
	# actually execute the code
	copy( $input  , $output);
}
# we have now clobbered the path.c file, and need to copy a valid one from 1 dir up
# so that version on unix cluster will compile & execute
copy( "u:/cloudy/trunk/path.c" , "u:/cloudy/trunk/source/path.c" );

# ----------------------------------------------------------
# now create compressed archives of the files we created
chdir( "$unixhome" ) or die " invalid unix home directory for source\n";
print(" moved to unix home directory\n");

# remove old gzipd file if it exists
if( -e "source.tar.gz" )
{
   unlink("source.tar.gz" );
}

#   tar the files
chdir( "$local_unix_source_dir" ) or die " invalid directory for local unix source\n";
$tarfile = "../"."source.tar";
system "tar -cf $tarfile * ";
print( "about to gzip $tarfile\n" );
system "gzip $tarfile ";


# move to main dir so that we can copy tar.gz files to ftp site
chdir( "$local_unix_main_dir" ) or die " invalid directory for main unix\n";
# finally copy the newly created files to the ftp site
copy( "source.tar.gz" , $ftp_last );

# how go to win home and zip the win source dir
#
# move to win home directory
chdir( "$winhome" ) or die " invalid directory for win home\n";
if( -e "source.zip" )
{
   unlink("source.zip" );
}

# win source
system "c:\\u\\wzzip source.zip $local_win_source_dir ";

# finally copy the newly created files to the ftp site
copy( "source.zip" , $ftp_last );

print("\n=========================\n");

